rollout Distancer "Distancer v2.0" width:264 height:236 (
	local pointTarget1
	local pointTarget2
	local calcXPerc
	local calcYPerc
	local calcZPerc
	local repositionObj
	local objHasPathConst
	local targetLine
	local globalReposition = false
	local lineArray
	local lineSegArray
	local linePoint
	local calcLinePerc
	local calcSegPiece = 0
	
	fn filterLine obj = (
		if classof obj == Line then (
			true
		)else if classof obj == SplineShape then (
			true
		)else (
			false
		)
	)

	groupBox grp1 "Position Obj" pos:[8,40] width:120 height:156
	groupBox grp2 "Path Constraint Obj" pos:[136,40] width:120 height:188
	pickButton pickPointTarget1 "Pick point target 1" pos:[16,60] width:104 height:24 tooltip:"Pick fist point (to work with distance between two points)"
	pickButton pickPointTarget2 "Pick point target 2" pos:[16,88] width:104 height:24 tooltip:"Pick second point (to work with distance between two points)"
	pickButton pickRepositionObj "Pick reposition obj" pos:[8,8] width:124 height:24 tooltip:"Pick object that you want to use. You gonna be able to change position of this object in the way you want"
	pickButton pickTargetLine "Pick target spline" pos:[144,60] width:104 height:24 filter:filterLine tooltip:"Pick the line that you want to work with (to work with line distance). If objects that are attached to the line with path constraint are currently selected then they will be deployed along the line after picking line target"
	spinner spinDivision "division" pos:[160,12] width:96 height:16 range:[0,100,3] type:#Float tooltip:"Set reposition steps by dividing distance"
	spinner spinVertex "vertex " pos:[160,130] width:88 height:16 range:[1,100,1] type:#Integer tooltip:"Jump to specific vertex position"
	button btnGlobalReposition "Segment Reposition" pos:[144,92] width:104 height:32 tooltip:"Change mode to 'Global' or 'Segment' (full length of line or length of segment determined by vertex)"
	button btnRepositionR "Reposition >>" pos:[16,120] width:104 height:32 tooltip:"Change position (positive reposition step)"
	button btnRepositionL "<< Reposition" pos:[16,156] width:104 height:32 tooltip:"Change position (negative reposition step)"
	button btnPathRepositionR "Reposition >>" pos:[144,152] width:104 height:32 tooltip:"Change position (positive reposition step)"
	button btnPathRepositionL "<< Reposition" pos:[144,188] width:104 height:32 tooltip:"Change position (negative reposition step)"
	button btnResetController "Reset Controllers" pos:[8,202] width:120 height:26 tooltip:"You can use it to remove constraints without affecting positions of objects. This will reset controllers of selected objects in non destructive way"

	fn fnVertexReposition = (
		if repositionObj != undefined then (
			if objHasPathConst == true then (
				if targetLine != undefined then (
					linePoint = spinVertex.value
					calcSegPiece = 0
					calcLinePerc = lineArray[linePoint+numKnots targetLine] / lineArray[lineArray.count] * 100
					repositionObj.pos.controller.Path_Constraint.controller.percent = calcLinePerc
				) else (
					messagebox"Need to choose target line"
				)
			) else (
				messagebox"Need reposition obj with path constraint"
			)
		) else (
			messagebox"Need to choose reposition obj"
		)
	)
	
	fn fnSegmentReposition direction = (
		if repositionObj != undefined then (
			if objHasPathConst == true then (
				if targetLine != undefined then (
					if globalReposition == false then (
						calcSegPiece = direction*lineSegArray[linePoint+numKnots targetLine+(direction+1)/2]/spinDivision.value+calcSegPiece
						calcLinePerc = (lineArray[linePoint+numKnots targetLine]+calcSegPiece) / lineArray[lineArray.count] * 100
						repositionObj.pos.controller.Path_Constraint.controller.percent = calcLinePerc
					) else (
						calcSegPiece = 100/spinDivision.value+calcSegPiece
						repositionObj.pos.controller.Path_Constraint.controller.percent = direction*calcSegPiece-(direction+1)/2*100
					)
				) else (
					messagebox"Need to choose target line"
				)
			) else (
				messagebox"Need reposition obj with path constraint"
			)
		) else (
			messagebox"Need to choose reposition obj"
		)
	)
	
	fn fnRepositionObj direction = (
		if repositionObj == undefined then messagebox"Need to choose reposition obj"
		else (
			if pointTarget1 == undefined then messagebox"Need to choose point target 1"
			else (
				if pointTarget2 == undefined then messagebox"Need to choose point target 2"
				else (
					calcXPerc = (pointTarget1.pos.x - pointTarget2.pos.x)/spinDivision.value
					calcYPerc =  (pointTarget1.pos.y - pointTarget2.pos.y)/spinDivision.value
					calcZPerc = (pointTarget1.pos.z - pointTarget2.pos.z)/spinDivision.value
					repositionObj.pos.x = repositionObj.pos.x - calcXPerc*direction 
					repositionObj.pos.y = repositionObj.pos.y - calcYPerc*direction
					repositionObj.pos.z = repositionObj.pos.z - calcZPerc*direction
				)
			)
		)
	)
	
	on btnResetController pressed do (
		for o in selection do (
			o.Transform.controller = Link_Constraint ()
			o.Transform.controller = prs ()
		)
	)
	
	on pickPointTarget1 picked obj do (
		pointTarget1 = obj
		pickPointTarget1.text = obj.name
		pickPointTarget1.enabled = true
	)
	
	on pickPointTarget2 picked obj do (
		pointTarget2 = obj
		pickPointTarget2.text = obj.name
		pickPointTarget2.enabled = true
	)
	
	on pickRepositionObj picked obj do (
		repositionObj = obj
		pickRepositionObj.text = obj.name
		pickRepositionObj.enabled = true
		try (
			tryController = repositionObj.pos.controller.Path_Constraint.controller.percent
			objHasPathConst = true
		) catch (
			objHasPathConst = false
		)
	)
	
	on pickTargetLine picked obj do (
		targetLine = obj
		lineArray = getSegLengths  targetLine 1 cum:true byVertex:true numArcSteps:100
		lineSegArray = getSegLengths  targetLine 1 cum:false byVertex:true numArcSteps:100
		spinVertex.range = [1,lineArray.count-numKnots targetLine,spinVertex.value]
		pickTargetLine.text = obj.name
		pickTargetLine.enabled = true
		if repositionObj != undefined then (
			fnVertexReposition()
		)
		local int pos = 0
		linePoint = spinVertex.value
		local sel = selection as array
		local selLen = sel.count
		if selLen > 1 then (
			if targetLine != undefined then (
				local piece = 100.0/(selLen-1)
				for ob in selection do (
					if isProperty ob.pos.controller #Path_Constraint == true then (
						ob.pos.controller.Path_Constraint.controller.percent = pos*piece
						pos += 1
					)else (
						messagebox"All selected objects should use path constraint!"
						return false
					)
				)
			)else (
					messagebox"Need to choose target line"
			)
		)
	)
	
	on spinVertex changed val do (
		if repositionObj != undefined then (
			if targetLine != undefined then (
				fnVertexReposition()
			)
		)
	)
	
	on btnGlobalReposition pressed do (
		if globalReposition == false then (
			globalReposition = true
			btnGlobalReposition.text = "Global Reposition"
		) else (
			globalReposition = false
			btnGlobalReposition.text = "Segment Reposition"
		)
	)
	
	on btnPathRepositionR pressed do (
		fnSegmentReposition 1
	)
	
	on btnPathRepositionL pressed do (
		fnSegmentReposition -1
	)	
	
	on btnRepositionR pressed do (
		fnRepositionObj 1
	)
	
	on btnRepositionL pressed do (
		fnRepositionObj -1
	)
)
createDialog Distancer style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox, #style_maximizebox)